//+------------------------------------------------------------------+
//|                                                timeout_close.mq4 |
//|                                        Copyright  2010 ........ |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010 ........"
#property link      ""

extern int ms_frequency = 200;

extern int slippage = 10;
extern int max_sec  = 60;


//string inst;


///==============================================================================================================================================================
void check_trades () {


for (int i = 0; i <= OrdersTotal(); i++){//loop through all the trades

if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;

//if(OrderSymbol() != inst)continue;

if(TimeCurrent() - OrderOpenTime() > max_sec) close();

}

}
///==============================================================================================================================================================
bool close () {

RefreshRates();

double price;

if(OrderType() == OP_BUY) {

price = MarketInfo(OrderSymbol(),MODE_BID);

}else if (OrderType() == OP_SELL) {

price = MarketInfo(OrderSymbol(),MODE_ASK);

}

if(OrderClose(OrderTicket(),OrderLots(),price,slippage)){

 Print("Order closed");
 

}else {
  
 Print("Falied to close the trade : " + str_lasterror()); 
 
 
}

}
///==============================================================================================================================================================
int init()
  {
//----
   //inst = Symbol();
 
 while(!IsStopped()) {
 
   check_trades();

  Sleep(ms_frequency);

}

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   check_trades();
//----
   return(0);
  }
///==============================================================================================================================================================
string str_lasterror () {
   
   switch (GetLastError()) {
      case 0:
         return ("");
      case 1:
         return ("no error");
         break;
      case 2:
         return ("common error");
         break;
      case 3:
         return ("invalid trade parameters");
         break;
      case 4:
         return ("trade server is busy");
         break;
      case 5:
         return ("old version of the client terminal");
         break;
      case 6:
         return ("no connection with trade server");
         break;
      case 7:
         return ("not enough rights");
         break;
      case 8:
         return ("too frequent requests");
         break;
      case 9:
         return ("malfunctional trade operation (never returned error)");
         break;
      case 64:
         return ("account disabled");
         break;
      case 65:
         return ("invalid account");
         break;
      case 128:
         return ("trade timeout");
         break;
      case 129:
         return ("invalid price");
         break;
      case 130:
         return ("invalid stops");
         break;
      case 131:
         return ("invalid trade volume");
         break;
      case 132:
         return ("market is closed");
         break;
      case 133:
         return ("trade is disabled");
         break;
      case 134:
         return ("not enough money");
         break;
      case 135:
         return ("price changed");
         break;
      case 136:
         return ("off quotes");
         break;
      case 137:
         return ("broker is busy (never returned error)");
         break;
      case 138:
         return ("requote");
         break;
      case 139:
         return ("order is locked");
         break;
      case 140:
         return ("long positions only allowed");
         break;
      case 141:
         return ("too many requests");
         break;
      case 145:
         return ("modification denied because order too close to market");
         break;
      case 146:
         return ("trade context is busy");
         break;
      case 147:
         return ("expirations are denied by broker");
         break;
      case 148:
         return ("amount of open and pending orders has reached the limit");
         break;
      case 4000:
         return ("no error (never generated code)");
         break;
      case 4001:
         return ("wrong function pointer");
         break;
      case 4002:
         return ("array index is out of range");
         break;
      case 4003:
         return ("no memory for function call stack");
         break;
      case 4004:
         return ("recursive stack overflow");
         break;
      case 4005:
         return ("not enough stack for parameter");
         break;
      case 4006:
         return ("no memory for parameter string");
         break;
      case 4007:
         return ("no memory for temp string");
         break;
      case 4008:
         return ("not initialized string");
         break;
      case 4009:
         return ("not initialized string in array");
         break;
      case 4010:
         return ("no memory for array\' string");
         break;
      case 4011:
         return ("too long string");
         break;
      case 4012:
         return ("remainder from zero divide");
         break;
      case 4013:
         return ("zero divide");
         break;
      case 4014:
         return ("unknown command");
         break;
      case 4015:
         return ("wrong jump (never generated error)");
         break;
      case 4016:
         return ("not initialized array");
         break;
      case 4017:
         return ("dll calls are not allowed");
         break;
      case 4018:
         return ("cannot load library");
         break;
      case 4019:
         return ("cannot call function");
         break;
      case 4020:
         return ("expert function calls are not allowed");
         break;
      case 4021:
         return ("not enough memory for temp string returned from function");
         break;
      case 4022:
         return ("system is busy (never generated error)");
         break;
      case 4050:
         return ("invalid function parameters count");
         break;
      case 4051:
         return ("invalid function parameter value");
         break;
      case 4052:
         return ("string function internal error");
         break;
      case 4053:
         return ("some array error");
         break;
      case 4054:
         return ("incorrect series array using");
         break;
      case 4055:
         return ("custom indicator error");
         break;
      case 4056:
         return ("arrays are incompatible");
         break;
      case 4057:
         return ("global variables processing error");
         break;
      case 4058:
         return ("global variable not found");
         break;
      case 4059:
         return ("function is not allowed in testing mode");
         break;
      case 4060:
         return ("function is not confirmed");
         break;
      case 4061:
         return ("send mail error");
         break;
      case 4062:
         return ("string parameter expected");
         break;
      case 4063:
         return ("integer parameter expected");
         break;
      case 4064:
         return ("double parameter expected");
         break;
      case 4065:
         return ("array as parameter expected");
         break;
      case 4066:
         return ("requested history data in update state");
         break;
      case 4099:
         return ("end of file");
         break;
      case 4100:
         return ("some file error");
         break;
      case 4101:
         return ("wrong file name");
         break;
      case 4102:
         return ("too many opened files");
         break;
      case 4103:
         return ("cannot open file");
         break;
      case 4104:
         return ("incompatible access to a file");
         break;
      case 4105:
         return ("no order selected");
         break;
      case 4106:
         return ("unknown symbol");
         break;
      case 4107:
         return ("invalid price parameter for trade function");
         break;
      case 4108:
         return ("invalid ticket");
         break;
      case 4109:
         return ("trade is not allowed in the expert properties");
         break;
      case 4110:
         return ("longs are not allowed in the expert properties");
         break;
      case 4111:
         return ("shorts are not allowed in the expert properties");
         break;
      case 4200:
         return ("object is already exist");
         break;
      case 4201:
         return ("unknown object property");
         break;
      case 4202:
         return ("object is not exist");
         break;
      case 4203:
         return ("unknown object type");
         break;
      case 4204:
         return ("no object name");
         break;
      case 4205:
         return ("object coordinates error");
         break;
      case 4206:
         return ("no specified subwindow");
      default:
         return ("unknown error");
   }

} 



